#!/usr/bin/env python
import sys
from collections import Counter

#ix_counts = Counter()

series = {} # keyed by timestamps at BIN size interval
BIN = 15*60

with open("infras.pairs.txt", 'rt') as inf:
    for line in inf:
        line = line.rstrip('\n')
        fields = line.split()
        infras = []
        ts = int( fields[2] )
        ts_bin = ts - ( ts % BIN )
        series.setdefault( ts_bin, {} )
        if len( fields ) == 5:
            first_infra = fields[4].split('|')[0]
            series[ ts_bin ].setdefault( first_infra, 0 )
            series[ ts_bin ][ first_infra ] += 1
            
        else:
            #ix_counts[ 'None' ] += 1
            series[ ts_bin ].setdefault('None', 0 )
            series[ ts_bin ]['None'] += 1

tsbin_min = min( series.keys() )
tsbin_max = max( series.keys() )

#infras_ordered = list( map( lambda x: x[0], ix_counts.most_common() ) )


tsnow = tsbin_min
ix_max_counts = {}
while tsnow <= tsbin_max:
    for infra in series[tsnow].keys():
        if not infra in ix_max_counts:
            ix_max_counts[infra] = series[ tsnow ][ infra ]
        elif ix_max_counts[ infra ] < series[ tsnow ][ infra ]:
            ix_max_counts[infra] = series[ tsnow ][ infra ]
    tsnow += BIN

infras_ordered = sorted( ix_max_counts.keys(), key=lambda x: ix_max_counts[ x ], reverse=True )

print('#ts ' + " ".join(infras_ordered) )
tsnow = tsbin_min
while tsnow <= tsbin_max:
    counts = []
    for infra in infras_ordered:
        cnt = 0
        if tsnow in series: 
            if infra in series[ tsnow ]:
                cnt = series[ tsnow ][ infra ]
        counts.append( str( cnt ) )
    print( tsnow, " ".join( counts ) )
    tsnow += BIN
